import javax.swing.*;
import javax.swing.text.*;
import javax.swing.tree.*;

import java.awt.*;
import java.awt.event.*;

import java.net.*;

import java.io.IOException;
import java.util.StringTokenizer;

public class GUI {
	final protected TabbedChat tabbedChat = new TabbedChat();
	final protected UserList userList = new UserList();

	public GUI() {
		final JFrame frame = new JFrame(DMC.getVersion());

		try {
			UIManager.setLookAndFeel(
				UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {}


		frame.getContentPane().setLayout(new BorderLayout());
		frame.getContentPane().add(createComponents(), BorderLayout.CENTER);
		frame.addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				System.exit(0);
			}
		});

		frame.pack();
		frame.setSize (480, 320);
		frame.show();

	}


	protected Component createComponents() {
		final JPanel pane = new JPanel();
		pane.setLayout(new BorderLayout());

		pane.add(tabbedChat.getUI(), BorderLayout.CENTER);
		pane.add(userList.getUI(), BorderLayout.EAST);

		return pane;

	}

}
