import javax.swing.*;
import javax.swing.text.*;
import javax.swing.tree.*;

import java.awt.*;
import java.awt.event.*;

import wtalk.WTalk;

public class JChatPanel extends JPanel {

	static final public int SYSTEM_TAB	= 0;
	static final public int IM_TAB   	= 1;
	static final public int CHAT_TAB	= 2;

	final protected JTextPane textChat = new JTextPane();
	final protected JScrollPane chatScroll = new JScrollPane(textChat);
	final protected JTextField textInput = new JTextField();
	protected WTalk wt = null;
	protected ChatInputHandler chi = null;
	protected String CurrentRoom = null;

	public JChatPanel(TabbedChat c, WTalk w, String room) {
		super();

		textChat.setEditable(false);
		chatScroll.setVerticalScrollBarPolicy( JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		chatScroll.setMinimumSize(new Dimension(10, 10));

		initTextStyles(textChat);
		//InitReaders(textChat);

		chi = new ChatInputHandler(CurrentRoom=room, textChat, c, wt=w);

		textInput.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				String s;
				Document d = textInput.getDocument();
				int len = d.getLength();

				try {
					s = d.getText(0, len);
					chi.doInput(s);
					d.remove(0, len);
					textChat.scrollRectToVisible(new Rectangle(0, textChat.getHeight(), 1, 1));
				} catch (BadLocationException ble){}
			}
		});

		//setBorder(BorderFactory.createEmptyBorder( 10, 10, 10, 10);
		setLayout(new BorderLayout());
		add(chatScroll, BorderLayout.CENTER);
		add(textInput, BorderLayout.SOUTH);
	
	}

	public JTextPane getJTextPane(){
		return textChat;
	}


	protected void initTextStyles(JTextPane textPane) {
		// Initizlize some default styels.
		Style def = StyleContext.getDefaultStyleContext().
			getStyle(StyleContext.DEFAULT_STYLE);

		Style regular  = textPane.addStyle("regular", def);
		StyleConstants.setFontFamily(def, "SansSerif");

		Style s = null;

		s = textPane.addStyle("client", regular);
		StyleConstants.setBold(s, true);
		StyleConstants.setForeground(s, new Color(100, 50, 0));

		s = textPane.addStyle("wall", regular);
		StyleConstants.setBold(s, true);
		StyleConstants.setForeground(s, new Color(0, 0, 200));

		s = textPane.addStyle("server", regular);
		StyleConstants.setBold(s, true);
		//StyleConstants.setItalic(s, true);
		StyleConstants.setForeground(s, new Color(200, 0, 0));

		s = textPane.addStyle("private", regular);
		StyleConstants.setItalic(s, true);
		StyleConstants.setForeground(s, new Color(0, 200, 200));

		s = textPane.addStyle("chat", regular);

		s = textPane.addStyle("isay", regular);
		StyleConstants.setBold(s, true);
		StyleConstants.setForeground(s, new Color(0, 0, 200));

		s = textPane.addStyle("usay", regular);
		StyleConstants.setBold(s, true);
		StyleConstants.setForeground(s, new Color(200, 0, 0));
	}

}
