package wtalk.protocols;

import wtalk.RMsgHandler;
import java.io.IOException;

public interface WTalkProtocol {

	//
	// Callbacks
	//
	public void setReceivedMessageHandler(RMsgHandler r);	// Default
	public void setChatMessageHandler(RMsgHandler r);	// Chats
	public void setPrivateMessageHandler(RMsgHandler r);	// Private
	public void setWallMessageHandler(RMsgHandler r);	// Walls
	public void setSystemMessageHandler(RMsgHandler r);	// System..

	//
	// Uncooked functions
	//
	public void sendRaw(String msg); 	// sends literal string
	//public void interpret(String cmd);	// Interpret a command


	//
	// Authentication/Login
	//
	public void connect() throws IOException; 	// includes sign-on
	public void connect(String login) throws IOException;
	public void connect(String server, int port) throws IOException;
	public void connect(String server, int port, String login) throws IOException;
	public void disconnect(String msg); 	// includes sign-off
	public boolean isConnected();	// Are we currently connected?

	public void setName(String name); 	// sets handle
	public String getName();
	//public void setPassword(String old, String new); 

	public void setServer(String server);	// sets server -- SHOULD NOT connect
	public String getServer();	// returns name of current server
	public void setServerPort(int port);
	public int getServerPort();



	//
	// IM functions
	//
	public void sendMessage(String to, String data); 
	public void whois(String user);

	//addBuddy();
	//removeBuddy();
	//listBuddies();

	//addDeny();
	//removeDeny();


	//
	// Chat functions
	//
	public void joinChat(String room);
	public void partChat(String room); 

	public void chatMessage(String room, String data);
	public void setTopic(String room, String topic); 
	public void chatList(String room);	// room may be null!



	//
	// Admin functions
	//
	public void sendWall(String msg);
}
